import { Component, OnInit } from '@angular/core';
import { FormBuilder } from '@angular/forms'

import { map } from 'rxjs/operators'

import { ActivatedRoute, Router} from '@angular/router'
import { AuthService, AuthSession } from './auth.service';
import { PolicyService } from './policy.service';

@Component({
  selector: 'app-root',
  templateUrl: './app.component.html',
  styleUrls: ['./app.component.scss']
})

export class AppComponent {
  public title = 'policyservice';
  public health = this.api.getHealth().pipe(
    map((resp) => resp.message),
  )

  public displayedColumns = [
    'id',
    'name',
  ];
  public someArray = [
    { name: 'some row', id: 13 },
  ];

  constructor(
    private api: PolicyService,
    private fb: FormBuilder,
    private route: ActivatedRoute,
    private router: Router,
    public authService: AuthService,
  ) {
  }

  /*
  info(){
    this.router.navigate(['info'], {relativeTo:this.route});
  }
  */
}
