import { Injectable } from '@angular/core'
import { HttpClient } from '@angular/common/http'

export interface AuthSession {
  dataPartionId: string
  userId: string
  token: string
}

@Injectable()
export class AuthService {
  public hasSession(): boolean {
    return !!this.session?.token
  }
  
  public get session(): AuthSession {
    const session = localStorage.getItem('session')

    if (session != null) {
      try {
        return JSON.parse(session)
      } catch (ex) {}
    }

    return {
      dataPartionId: '',
      token: '',
      userId: '',
    }
  }

  public set session(session: AuthSession) {
    localStorage.setItem('session', JSON.stringify(session))
  }

  public killSession(): void {
    localStorage.removeItem('session')
  }
}
