import { Component, OnInit } from '@angular/core';
import { FormBuilder } from '@angular/forms'
import { ActivatedRoute, Router} from '@angular/router'

import { AuthService } from '../auth.service';

@Component({
  selector: 'app-login',
  templateUrl: './login.component.html',
})
export class LoginComponent {
  constructor(
    private fb: FormBuilder,
    private route: ActivatedRoute,
    private router: Router,
    public authService: AuthService,
  ) {
  }

  public sessionForm = this.fb.group({
    dataPartionId: [this.authService.session.dataPartionId],
    token: [this.authService.session.token],
    userId: [this.authService.session.userId],
  })

  updateSession() {
    this.authService.session = this.sessionForm.value as any

    if (this.authService.hasSession()) {
      this.router.navigateByUrl('/info')
    }
  }
}
